<?php

namespace App\Models\Customer;

use App\Entities\Customer\ServiceItemEntity;

class ServiceItemModel extends CustomerModel
{
    const TABLE = "serviceinfo_items";
    const PK = "uid";
    const TITLE = "item_type";
    protected $table            = self::TABLE;
    protected $primaryKey       = self::PK;
    protected $returnType       = ServiceItemEntity::class;
    protected $allowedFields = [
        "serviceinfo_uid",
        "code",
        "item_type",
        "item_uid",
        "billing_cycle",
        "price",
        "amount",
        "start_at",
        "end_at",
        "status",
        "updated_at"
    ];
    public function __construct()
    {
        parent::__construct();
    }
    public function getFormFieldRule(string $action, string $field): string
    {
        if (is_array($field)) {
            throw new \Exception(__FUNCTION__ . "=> field가 array 입니다.\n" . var_export($field, true));
        }
        switch ($field) {
            case "serviceinfo_uid":
            case "item_uid":
            case "price":
            case "amount":
                $rule  = "required|numeric";
                break;
            case "item_type":
            case "billing_cycle":
            case "status":
                $rule = "required|trim|string";
                break;
            case "start_at":
                $rule = "required|valid_date";
                break;
            case "end_at":
                $rule = "if_exist|valid_date";
                break;
            default:
                $rule = parent::getFormFieldRule($action, $field);
                break;
        }
        return $rule;
    }
}
